using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using System.Runtime.InteropServices; // needed for DllImport
using System.Text; // needed for StringBuilder Class
using System.IO;

namespace wsq_demo
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
        private WSQImageLibraryNativeMethods WSQ_library_native_methods;


		private System.Windows.Forms.Button buttonOpen;
		private System.Windows.Forms.Button buttonSave;
		private System.Windows.Forms.PictureBox picture;
		private System.Windows.Forms.Button buttonStreamToWSQ;
		private System.Windows.Forms.Button buttonWSQtoStream;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;


		private IntPtr bp;
		private System.Drawing.Bitmap b;
		private byte[] input_data_stream;
		private byte[] input_data_stream2;
		private byte[] output_data_stream;
		private byte[] output_data_stream2;
		private Int32 width;
		private Int32 height;
		private Int32 ppi;
		private double bitrate;
		private System.Windows.Forms.TextBox textBoxAuthorizationCode;
		private System.Windows.Forms.TextBox textBoxSerialNumber;
		private System.Windows.Forms.Label labelAuthorizationCode;
		private System.Windows.Forms.Label labelSerialNumber;
		private System.Windows.Forms.Button buttonUnlockProgram;
		private System.Windows.Forms.Button buttonGenerateSerialNumber;
		private String comment_text;



		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
           WSQ_library_native_methods = new WSQImageLibraryNativeMethods();


		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.buttonOpen = new System.Windows.Forms.Button();
			this.buttonSave = new System.Windows.Forms.Button();
			this.picture = new System.Windows.Forms.PictureBox();
			this.buttonStreamToWSQ = new System.Windows.Forms.Button();
			this.buttonWSQtoStream = new System.Windows.Forms.Button();
			this.textBoxAuthorizationCode = new System.Windows.Forms.TextBox();
			this.textBoxSerialNumber = new System.Windows.Forms.TextBox();
			this.labelAuthorizationCode = new System.Windows.Forms.Label();
			this.labelSerialNumber = new System.Windows.Forms.Label();
			this.buttonUnlockProgram = new System.Windows.Forms.Button();
			this.buttonGenerateSerialNumber = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// buttonOpen
			// 
			this.buttonOpen.Location = new System.Drawing.Point(16, 312);
			this.buttonOpen.Name = "buttonOpen";
			this.buttonOpen.Size = new System.Drawing.Size(104, 32);
			this.buttonOpen.TabIndex = 0;
			this.buttonOpen.Text = "&Open";
			this.buttonOpen.Click += new System.EventHandler(this.buttonOpen_Click);
			// 
			// buttonSave
			// 
			this.buttonSave.Enabled = false;
			this.buttonSave.Location = new System.Drawing.Point(128, 312);
			this.buttonSave.Name = "buttonSave";
			this.buttonSave.Size = new System.Drawing.Size(104, 32);
			this.buttonSave.TabIndex = 2;
			this.buttonSave.Text = "&Save";
			this.buttonSave.Click += new System.EventHandler(this.buttonSave_Click);
			// 
			// picture
			// 
			this.picture.Location = new System.Drawing.Point(16, 16);
			this.picture.Name = "picture";
			this.picture.TabIndex = 4;
			this.picture.TabStop = false;
			// 
			// buttonStreamToWSQ
			// 
			this.buttonStreamToWSQ.Enabled = false;
			this.buttonStreamToWSQ.Location = new System.Drawing.Point(128, 352);
			this.buttonStreamToWSQ.Name = "buttonStreamToWSQ";
			this.buttonStreamToWSQ.Size = new System.Drawing.Size(104, 32);
			this.buttonStreamToWSQ.TabIndex = 6;
			this.buttonStreamToWSQ.Text = "Stream -> WSQ";
			this.buttonStreamToWSQ.Click += new System.EventHandler(this.buttonStreamToWSQ_Click);
			// 
			// buttonWSQtoStream
			// 
			this.buttonWSQtoStream.Location = new System.Drawing.Point(16, 352);
			this.buttonWSQtoStream.Name = "buttonWSQtoStream";
			this.buttonWSQtoStream.Size = new System.Drawing.Size(104, 32);
			this.buttonWSQtoStream.TabIndex = 5;
			this.buttonWSQtoStream.Text = "WSQ -> stream";
			this.buttonWSQtoStream.Click += new System.EventHandler(this.buttonWSQtoStream_Click);
			// 
			// textBoxAuthorizationCode
			// 
			this.textBoxAuthorizationCode.Location = new System.Drawing.Point(16, 284);
			this.textBoxAuthorizationCode.Name = "textBoxAuthorizationCode";
			this.textBoxAuthorizationCode.Size = new System.Drawing.Size(336, 20);
			this.textBoxAuthorizationCode.TabIndex = 16;
			this.textBoxAuthorizationCode.Text = "";
			this.textBoxAuthorizationCode.Visible = false;
			// 
			// textBoxSerialNumber
			// 
			this.textBoxSerialNumber.Location = new System.Drawing.Point(16, 228);
			this.textBoxSerialNumber.Name = "textBoxSerialNumber";
			this.textBoxSerialNumber.Size = new System.Drawing.Size(336, 20);
			this.textBoxSerialNumber.TabIndex = 15;
			this.textBoxSerialNumber.Text = "";
			// 
			// labelAuthorizationCode
			// 
			this.labelAuthorizationCode.Location = new System.Drawing.Point(16, 260);
			this.labelAuthorizationCode.Name = "labelAuthorizationCode";
			this.labelAuthorizationCode.Size = new System.Drawing.Size(168, 16);
			this.labelAuthorizationCode.TabIndex = 14;
			this.labelAuthorizationCode.Text = "Authorization code";
			this.labelAuthorizationCode.Visible = false;
			// 
			// labelSerialNumber
			// 
			this.labelSerialNumber.Location = new System.Drawing.Point(16, 204);
			this.labelSerialNumber.Name = "labelSerialNumber";
			this.labelSerialNumber.Size = new System.Drawing.Size(168, 16);
			this.labelSerialNumber.TabIndex = 13;
			this.labelSerialNumber.Text = "Serial number";
			// 
			// buttonUnlockProgram
			// 
			this.buttonUnlockProgram.Enabled = false;
			this.buttonUnlockProgram.Location = new System.Drawing.Point(248, 352);
			this.buttonUnlockProgram.Name = "buttonUnlockProgram";
			this.buttonUnlockProgram.Size = new System.Drawing.Size(104, 32);
			this.buttonUnlockProgram.TabIndex = 12;
			this.buttonUnlockProgram.Text = "&Unlock Program";
			this.buttonUnlockProgram.Click += new System.EventHandler(this.buttonUnlockProgram_Click);
			// 
			// buttonGenerateSerialNumber
			// 
			this.buttonGenerateSerialNumber.Location = new System.Drawing.Point(248, 312);
			this.buttonGenerateSerialNumber.Name = "buttonGenerateSerialNumber";
			this.buttonGenerateSerialNumber.Size = new System.Drawing.Size(104, 32);
			this.buttonGenerateSerialNumber.TabIndex = 10;
			this.buttonGenerateSerialNumber.Text = "&Generate Serial Number";
			this.buttonGenerateSerialNumber.Click += new System.EventHandler(this.buttonGenerateSerialNumber_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(376, 405);
			this.Controls.Add(this.textBoxAuthorizationCode);
			this.Controls.Add(this.textBoxSerialNumber);
			this.Controls.Add(this.labelAuthorizationCode);
			this.Controls.Add(this.labelSerialNumber);
			this.Controls.Add(this.buttonUnlockProgram);
			this.Controls.Add(this.buttonGenerateSerialNumber);
			this.Controls.Add(this.buttonStreamToWSQ);
			this.Controls.Add(this.buttonWSQtoStream);
			this.Controls.Add(this.buttonSave);
			this.Controls.Add(this.buttonOpen);
			this.Controls.Add(this.picture);
			this.Name = "Form1";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "WSQ Library Demo";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}



        // To call functions from WSQ_library.dll
		// you can use the methods from wrapper class WSQImageLibraryNativeMethods
		// or you can use function prototypes provided below 

		[DllImport("WSQ_library.dll")]
		public static extern IntPtr _CreateBMPFromFile(String lpszFileName);

		[DllImport("WSQ_library.dll")]
		public static extern void _SaveBMPToFile(IntPtr hBitmap, String filename, Int32 filetype);

		[DllImport("WSQ_library.dll")]
		public static extern IntPtr _ConvertHBITMAPtoGrayScale256(IntPtr hBitmap);

		[DllImport("WSQ_library.dll")]
		public static extern void _SaveHBITMAPtoFileAsGrayScale256BMP(IntPtr hBitmap, String filename);


		[DllImport("WSQ_library.dll")]
		public static extern void _RegisterWSQ();

		[DllImport("WSQ_library.dll")]
		public static extern String _GenerateSerialNumber();

		[DllImport("WSQ_library.dll")]
		public static extern Int32 _UnlockWSQLibrary(String authorization_code);




		private void buttonOpen_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog ofd = new OpenFileDialog();

			ofd.Filter = "All images|*.wsq;*.bmp;*.tiff;*.tif;*.jpg;*.jp2;*.jpc;*.jpe;*.jpeg;*.png;*.gif;*.iff;*.ico;*.wmf;" +
				"*.emf;*.jfif;*.rle;*.dib;*.win;*.vst;*.vda;*.tga;*.icb;*.fax;*.eps;*.pcx;*.pcc;*.scr; *.rpf;*.rla;*.sgi;" +
				"*.rgba;*.rgb;*.bw;*.psd;*.pdd;*.ppm;*.pgm;*.pbm;*.cel;*.pic;*.pcd;*.cut;*.psp;" +
				"|FBI Wavelet Scalar Quantization (*.wsq)|*.wsq" +
				"|Windows bitmaps (*.bmp)|*.bmp|Macintosh TIFF images (*.tiff)|*.tiff|PC TIFF images (*.tif)|*.tif" +
				"|JPG images (*.jpg)|*.jpg|JPEG-2000 Part-1 (*.jp2)|*.jp2|JPEG-2000 Code Stream (*.jpc)|*.jpc|JPE images (*.jpe)|*.jpe" + 
				"|JPEG images (*.jpeg)|*.jpeg|Portable network graphic images (*.png)|*.png" +
				"|Compuserve Graphic Interchange Format(*.gif)|*gif|Paintshop Pro images (*.psp)|*.psp|JFIF images (*.jfif)|*.jfif" +
				"|Run length encoded Windows bitmaps (*.rle)|*.rle|Device independant Windows bitmaps (*.dib)|*.dib" +
				"|Truevision images (*.win)|*.win|Truevision images (*.vst)|*.vst|Truevision images (*.vda)|*.vda" +
				"|Truevision images (*.tga)|*.tga|Truevision images (*.icb)|*.icb|GFI fax images (*.fax)|*.fax" +
				"|Encapsulated Postscript images (*.eps)|*.eps|ZSoft Paintbrush images (*.pcx)|*.pcx|ZSoft Paintbrush images (*.pcc)|*.pcc" +
				"|Word 5.x screen capture images (*.scr)|*.scr|Alias/Wavefront images (*.rpf)|*.rpf|Alias/Wavefront images (*.rla)|*.rla" +
				"|SGI true color images (*.sgi)|*.sgi|SGI true color images with alpha (*.rgba)|*.rgba|SGI true color images (*.rgb)|*.rgb" +
				"|SGI black/white images (*.bw)|*.bw|Photoshop images (*.psd)|*.psd|Photoshop images (*.pdd)|*.pdd" +
				"|Portable pixel map images (*.ppm)|*.ppm|Portable gray map images (*.pgm)|*.pgm|Portable bitmap images (*.pbm)|*.pbm" +
				"|Autodesk images (*.cel)|*.cel|Autodesk images (*.pic)|*.pic|Kodak Photo-CD images (*.pcd)|*.pcd" +
				"|Dr. Halo images (*.cut)|*.cut|Amiga Bitmap Graphic (8 bits)|*.iff|Windows icons (*.ico)|*.ico" +
				"|Windows metafiles (*.wmf)|*.wmf|Windows enhanced meta files (*.emf)|*.emf";


			ofd.FilterIndex = 1;
			if (ofd.ShowDialog() != DialogResult.OK)
			{
				return;
			}
			
			//you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
            //bp = _CreateBMPFromFile(ofd.FileName);
			bp = WSQ_library_native_methods.CreateBMPFromFile(ofd.FileName);
			b = Image.FromHbitmap(bp);
			picture.Image = b;
            
			Int32 h = picture.Image.Height;
			Int32 w = picture.Image.Width;
			picture.SetBounds(0, 0, w, h);

			buttonSave.Enabled = true;
		}

		private void buttonConvert_Click(object sender, System.EventArgs e)
		{
		}

		private void buttonSave_Click(object sender, System.EventArgs e)
		{
			SaveFileDialog sfd = new SaveFileDialog();
			sfd.Filter = "WSQ Files (*.wsq)|*.wsq|Windows BMP (*.bmp)|*.bmp|TIFF Files (*.tif)|*.tif"+
				"|PNG Files (*.png)|*.png|JPEG Files (*.jpg)|*.jpg|Targa Files (*.tga)|*.tga|SGI Files (*.rgb)|*.rgb" +
				"|JPEG-2000 Part-1 (*.jp2)|*.jp2|JPEG-2000 Code Stream (*.jpc)|*.jpc";

			sfd.FilterIndex = 1;
			if (sfd.ShowDialog() != DialogResult.OK)
			{
				return;
			}

			//you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
            //_SetShowFilePropertiesDialog(1);
			//WSQ_library_native_methods.SetShowFilePropertiesDialog(1);

			Bitmap b;
			IntPtr bp;

			b = new Bitmap(picture.Image);
			bp = b.GetHbitmap();

			//you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
			//_SaveBMPToFile(bp, sfd.FileName, sfd.FilterIndex);
			WSQ_library_native_methods.SaveBMPToFile(bp, sfd.FileName, sfd.FilterIndex);
		}

		private void buttonRegister_Click(object sender, System.EventArgs e)
		{
		}

		private void buttonWSQtoStream_Click(object sender, System.EventArgs e)
		{
		
			OpenFileDialog ofd = new OpenFileDialog();

			ofd.Filter = "FBI Wavelet Scalar Quantization (*.wsq)|*.wsq";

			ofd.FilterIndex = 1;
			if (ofd.ShowDialog() != DialogResult.OK)
			{
				return;
			}

			FileInfo fInfo = new FileInfo (ofd.FileName);
			long input_stream_length = fInfo.Length;
			FileStream fStream = new FileStream(ofd.FileName, FileMode.Open, FileAccess.Read);
			BinaryReader br = new BinaryReader(fStream);

			input_data_stream = br.ReadBytes((int)input_stream_length);

			WSQ_library_native_methods.WSQ_decode_stream(input_data_stream, (int)input_stream_length,
				out output_data_stream, out width, out height, out ppi, out comment_text);

            //Converts WSQ compressed byte array into HBITMAP for showing on screen
			bp = WSQ_library_native_methods.CreateBMPFromWSQByteArray(input_data_stream, (int)input_stream_length);
			b = Image.FromHbitmap(bp);
			picture.Image = b;
            
			Int32 h = picture.Image.Height;
			Int32 w = picture.Image.Width;
			picture.SetBounds(0, 0, w, h);

			int output_data_stream_length = height * width;

			// Saves WSQ compressed byte array to an image file.
			//WSQ_library_native_methods.SaveWSQByteArrayToImageFile(input_data_stream, (int)input_stream_length, "C:\\OutputDirectory\\output.jpg", 5);


			MessageBox.Show("WSQ file was loaded into memory stream and decompressed into another memory stream.\nNow please press button \"stream -> WSQ\" to compress memory stream and save it to file.\nWSQ compressed byte array was converted to HBITMAP for showing on screen.");

			br.Close();
			fStream.Close();



			buttonStreamToWSQ.Enabled = true;
		
		}

		private void buttonStreamToWSQ_Click(object sender, System.EventArgs e)
		{

			SaveFileDialog sfd = new SaveFileDialog();
			sfd.Filter = "WSQ Files (*.wsq)|*.wsq";
			sfd.FilterIndex = 1;
			if (sfd.ShowDialog() != DialogResult.OK)
			{
				return;
			}


			bitrate = 0.75;
			ppi = 500;
			//comment_text = "";
			comment_text = "Cognaxon";


			input_data_stream2 = new byte[width*height];
			int row, row2, pixel_number, pixel_number2;

			// MAKE A MIRRORED/FLIPPED IMAGE (UP<->DOWN and LEFT<->RIGHT)
			for (int y = 0; y < height; y++)
			{
				row = width * y;
				row2 = width * (height - y - 1);
				for (int x = 0;  x < width; x++)
				{
					pixel_number = row + x;
					pixel_number2 = row2 + (width - x - 1);

					input_data_stream2[pixel_number2] = output_data_stream[pixel_number];
				}
			}


			int compressedLength;
			WSQ_library_native_methods.WSQ_encode_stream(input_data_stream2, width, height, 
				bitrate, ppi, comment_text, out output_data_stream2, out compressedLength);


			FileStream fStream = new FileStream(sfd.FileName, FileMode.CreateNew);
			BinaryWriter bw = new BinaryWriter(fStream);

			bw.Write(output_data_stream2);
			bw.Close();
			fStream.Close();
			MessageBox.Show("Memory stream was compressed into another memory stream and saved to WSQ file.\nNow please press button \"Open\", select the saved file, open it and have a look at the\nresults of memory stream processing. The processed image is mirrored/flipped\n(UP<->DOWN and LEFT<->RIGHT).");


		}

		private void buttonGenerateSerialNumber_Click(object sender, System.EventArgs e)
		{
		
			textBoxSerialNumber.Text = _GenerateSerialNumber();
			textBoxAuthorizationCode.Visible = true;
			labelAuthorizationCode.Visible = true;
			buttonUnlockProgram.Enabled = true;

		}

		private void buttonUnlockProgram_Click(object sender, System.EventArgs e)
		{

			Int32 result;

			result = _UnlockWSQLibrary(textBoxAuthorizationCode.Text);

			if (result == 1)
			{MessageBox.Show("Registration succeeded");}
			else
			{MessageBox.Show("Authorization code is invalid");}		
		}
	}
}
